/*
   This program tests the ParseJSON2AST parser.

   When this program runs, it creates dot and
   png files for each of the abstract syntax trees.

   You can download the installer for dot.exe from this URL.
     http://www.graphviz.org/pub/graphviz/stable/windows/graphviz-2.28.0.msi
*/

public class TestJSON3
{
   public static void main(String[] args)
   {
      String[] json =
      {
         "{ }",

         "{ a1 : [ 5 , 6 , 7 ]  }",

         "{ a1 : [ ] , a2 : [ ] }",

         "{ o1 : { } , a1 : [ ] , s1 : 3 }",

         "{ o1 : { x : 1 , y : 2 , z : 3 } , a1 : [ 123 , [ { x : 1 } , { y : 2 } , { z : 3 } ] ] , s1 : \"pears\" }"
      };


      for (int i = 0; i < json.length; i++)
      {
         try  // Build the AST for the data structure.
         {
            Tree parseTree = ParseJSON2AST.parse( json[i] );
            System.out.println( parseTree + "\n" );

            try  // Create dot and png files from the AST.
            {
               // Create the (empty) dot file.
               String baseName = String.format("JSON_%d_AST", i);
               java.io.PrintWriter out = new java.io.PrintWriter(
                                         new java.io.File(baseName + ".dot") );
               // Put dot commands into the dot file
               out.println("//  " + parseTree + "\n");
               out.println( Tree2dot.tree2dot(parseTree) + "\n" );
               out.close();
               // Create a command line for running dot.exe.
               String[] cmd = {"dot.exe",
                               "-Tpng",
                               baseName + ".dot",
                               "-o",
                               baseName + ".png"};
               // Execute the command line.
               java.lang.Runtime.getRuntime().exec(cmd);
            }
            catch (Exception e)
            {
               System.out.println( e );
            }
         }
         catch (Exception e)
         {
            System.out.println(e);
          //e.printStackTrace();
         }
      }
   }//main()

}//TestJSON23