/*
  This program tests the recursive descent parser
  for the grammar in Language_1_infix.txt.
*/

public class TestParseTree
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
         "123",
         "5 - 3",
         "5 - 3 * 2",
         "( 5 - 3 ) * 2",
         "1 + 2 + 3",
         "( 1 + 2 + 3 )",
         "6 % 2",
         "2 * ( 3 + 4 )",
         "2 ^ 3 ^ 4",
         "( 2 ^ 3 ) ^ 4",
         "3 * 4 + 5 * 6 + - 4",
         " - 3 * 4",
         "- ( 3 * 4 )",
         "- 3 ^ ( 1 + 2 )",
         "( 6 % 2 ) + ( 8 % 2 ) + ( 3 % 2 )",
         "( 1 + 2 ) ^ ( 4 * 5 )"
      };

      int i = 0;
      for (i = 0; i < exprs.length; i++)
      {
         System.out.println(i + " =============================================");

         // Print the expression.
         System.out.println( exprs[i] + "\n" );

         // Build the parse tree that represents the expression.
         try
         {
            Tree ast = Parse2ParseTree.parse( exprs[i] );

            // Print the AST as an S-expression
            System.out.println( ast + "\n" );

            // Create dot and png files from the AST.
            if(true)
            try
            {
               // Create the (empty) dot file.
               String baseName = String.format("Language_1_infix_%02d_ParseTree", i);
               java.io.PrintWriter out = new java.io.PrintWriter(
                                            new java.io.File(baseName + ".dot") );
               // Put dot commands into the dot file
               out.println( Tree2dot.tree2dot(ast) + "\n" );
               out.close();
               // Create a command line for running dot.exe.
               String[] cmd = {"dot.exe",
                               "-Tpng",
                               baseName + ".dot",
                               "-o",
                               baseName + ".png"};
               // Execute the command line.
               java.lang.Runtime.getRuntime().exec(cmd);
            }
            catch (Exception e)
            {
               System.out.println( e );
            }
         }
         catch (ParseException e)
         {
            System.out.println(e);
          //e.printStackTrace();
         }
      }
   }//main

}//TestParseTree